' 30-08-2022
' Turntable
' Started....12/05/22 added single step control 04-08-22
' Microcontroller used: Microchip Technology 12F675
' microchip.com
' PicBasic Pro Code: micro-Engineering Labs, Inc.
' melabs.com
'-------Program Desciption--------
' If the set switch is closed when the rotate push button is pressed then the turntable rotates 1 step. 
 'If the set switch is open when the rotate switch is pressed then the turntable rotates though 
' 180 degress. If the button is pressed when the turntable is rotating
'the command is ignorded until the turntable stops.
  #CONFIG
  __CONFIG    _CPD_OFF & _CP_OFF & _BODEN_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
  #ENDCONFIG
  
DEFINE OSC 4  'oscillator 4MHz
define OSCCAL_1K 1  'use the stored oscillator cal value to calibrate the oscillator 

 CMCON = 00000111  'comparitor off
 VRCON.7 = 0' comparitor voltage reference module off 
 ADCON0.0 = 0'  ADC off
 INTCON = %11010000  'interrupt GP2
OPTION_REG.7 = 1 'pull ups disabled
OPTION_REG.6 = 0 'interrupt on falling edge. 

ON INTERRUPT goto Rotate
 
 TRISIO = %00111100 'GP2, GP3 (MCRL),GP4 and GP5 inputs rest outputs
 ANSEL = %00000000 'all digital 
 
  '------------Variable-------------
  a var word  '  1 to 800 for step input 
  b var word 
 
  ' ending step value ie 180 degree rotation b = 800 (200X8/2) 
  '----------Initialization---------

 GPIO.1 = 1 ' stepper disabled
 GPIO.0 = 0 ' step output low
 a = 1
 b = 800 
 
'------------Main Code------------
 


  
    Start:
    'pause 5
    if GPIO.4 = 1 then b = 800
    if GPIO.4 = 0 then b = 1
   
     goto start
         
    
    disable:
    Rotate:
    GPIO.1 = 0' enable stepper motor
    for a = 1 to b
    GPIO.0 = 1 ' step input high
    pause 5 ' pause 5 
    GPIO.0 = 0 'step input low ie 1 step pulse
    pause 5
    next a
    GPIO.1 = 1 'disable stepper motor
    INTCON.1 = 0
    resume
    enable
